#!/usr/bin/env python

import os
import glob
import re
import translate

#Go
def go(output=True):

	#cd to the location of this file
	os.chdir(os.path.split(repr(__file__))[0][1:])
	here = os.path.join(os.getcwd(),'')

	#Translator object
	T = translate.Translate()

	#Empty translations file
	pot_file_array = {}

	#Start by translating the tours
	if os.path.exists(os.path.join(os.getcwd(), "tours")):
	
		#Loop through all the tours
		for path in glob.glob(os.path.join(os.getcwd(), "tours", "*")):
		
			#Deal with the info file
			page = os.path.join(path,"tour.info")
			f = open(page, 'r')
			config = f.read().split('\n')
			f.close()
		
			#Loop through the lines in the config file
			for n in range(len(config)):
				line = config[n]
			
				#Check line exists
				if len(line) > 2:
				
					#If we have a parameter
					if ':' in line and line[0] != '#':
						l = line.split(':',1)
					
						#If it is one of the parameters being translated
						if l[0] in ['name', 'description']:
						
							#The location
							pos = '#: ' + page[len(here):] + ':' + str(n + 1)
						
							#Do we already have this string?
							if l[1] in pot_file_array.keys():
							
								#Have we already got this position?
								if not pos in pot_file_array[l[1]]:
							
									#If not add it
									pot_file_array[l[1]].append(pos)
						
							#We don't already have this string
							else:
							
								#So add it
								pot_file_array[l[1]] = [pos]
		
		
			#Deal with the pages
			for page in glob.glob(os.path.join(path,"*_*.html")):
			
				#Open the page
				f = open(page, 'r')
				string = f.read()
				f.close()
			
				#Find translatable strings
				pot_file_array = T.create_pot_array(string, page[len(here):], pot_file_array)


	#Now format the pot file
	pot_file = ''

	#Loop through the strings
	for string in pot_file_array.keys():
	
		#Loop through the positions where this string is found
		for pos in pot_file_array[string]:
			#Add the position
			pot_file += pos + '\n'
	
		#Add the string
		pot_file += "msgid \"" + string.replace("\\","\\\\").replace("\"","\\\"").replace("\n", "\"\n\"") + "\"\n"
		pot_file += "msgstr \"\"\n\n"

	#Output
	f = open('po/ubuntutour.pot', 'w')
	f.write(pot_file)
	f.close()

	#Thats the hard bit, now get xgettext to get translations from the python files
	os.system('xgettext --keyword=__ --output=./po/ubuntutour.pot --force-po -j tour.py ubuntu-tour.py')

	#And output
	if output:
		os.system('cat po/ubuntutour.pot | more')


#If this is being called directly, then run it...
if __name__ == "__main__":
	go()
