#A file to hold all the dialogs which we may use.

#General imports
import os

#Using gtk
import gtk
import pygtk

#Some other imports
import tarfile	#For importing tours
import version	#For about
import webbrowser #For the bug reporter


#Import a tour
class Import:
	def __init__(self):
		#Create the chooser
		self.importwindow = gtk.FileChooserDialog(title='Import tours', action=gtk.FILE_CHOOSER_ACTION_OPEN, buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
		
		#Filter
		self.filter = gtk.FileFilter()
		self.filter.set_name("Tour files")
		self.filter.add_mime_type("application/tar")
		self.filter.add_pattern("*.tar")
		self.importwindow.add_filter(self.filter)
		self.importwindow.set_select_multiple(True)
	
	def run(self):
		#Run the dialog
		response = self.importwindow.run()
		
		#If the user ok'd
		if response == gtk.RESPONSE_OK:
			#Get the tours we are importing
			tours = self.importwindow.get_filenames()
			
			#Loop through the tours
			for tour in tours:
				
				#Can we read it?
				if tarfile.is_tarfile(tour):
					
					#Open
					archive = tarfile.open(tour)
					
					#And extract
					archive.extractall(os.path.join(os.path.expanduser('~'), ".ubuntu-tour", "tours"))
				
				#Else alert
				else:
					os.popen('zenity --error --text="The follow tour could not be loaded: %s"' % tour)
			
		#Otherwise he canceled, so just die
		self.importwindow.hide()



#Help About dialog
class About:
	def __init__(self):
		#Create the about window
		self.window = gtk.AboutDialog()
		self.window.set_icon_from_file(os.getcwd()+"/images/logo.svg")
		
		self.window.set_name(version.ProgramName)
		self.window.set_version(version.Version)
		self.window.set_copyright(version.Copyright)
		self.window.set_comments(version.Comments)
		#self.window.set_license(version.License)
		self.window.set_website(version.SiteURL)
		#self.window.set_website_label(version.SiteLabel)
		
		#self.window.set_authors(version.Authors)
		#self.window.set_documenters(version.Documenters)
		#self.window.set_artists(version.Artists)
		
		#self.window.set_translator_credits(version.TranslatorCredits)
		self.window.set_logo(gtk.gdk.pixbuf_new_from_file(os.getcwd()+"/images/logo.svg"))
		#self.window.set_logo_icon_name('icon_name')
		self.window.set_program_name(version.ProgramName)
	
	def run(self):
		#Run the dialog
		response = self.window.run()
		
		#Otherwise they canceled, so just die
		self.window.hide()


#Show a dialog
def Show(self, page):

	#File > Import
	if page == 'import':
		if self.importdialog == None:
			self.importdialog = Import()
		self.importdialog.run()
	
	#Help > About
	elif page == 'about':
		if self.aboutdialog == None:
			self.aboutdialog = About()
		self.aboutdialog.run()

	#Help > Report a bug
	#This should include which page the bug was found on.
	elif page == 'reportbug':
		Version = "Bug in version " + version.Version + ":%20"
		webbrowser.open("https://launchpad.net/ubuntu-tour/+filebug?field.title=" + Version)
