#!/usr/bin/python

import os
import sys
import platform


#Used to find things like -a (can be extracted from something like -abc).
def get_flag(flag):
	for arg in sys.argv:
		if len(arg) >= 2:
			if arg[0] == '-' and arg[1] != '-' and arg.find(flag) != -1:
				return True
	return False

#Used to find things like --version.
def get_argument(argument):
	return "--" + argument in sys.argv

#Check os version
def check_os(osys, required):
	# Are we using Ubuntu?
	if osys == platform.dist()[0]:
	
		#What version?
		version = platform.dist()[1].split('.')
		version = float(version[0] + '.' + version[1] + '0' + ''.join(version[2:]))
	
		#Is that high enough?
		if version >= required:
			return True
		else:
			return False
	else:
		return False

#Get default app
def GetDefaultApp(Type):
	App = ""
	if (Type.lower() == "browser"):
		App = os.popen("gconftool-2 -g /desktop/gnome/applications/browser/exec").read().rsplit("/", 1)[-1].replace("chromium-browser", "chromium")[:-1]
		return App
	elif (Type.lower() == "music" or Type.lower() == "media"):
		App = os.popen("gconftool-2 -g /desktop/gnome/applications/media/exec").read().rsplit("/", 1)[-1][:-1]
		return App
	elif (Type.lower() == "mail" or Type.lower() == "email"):
		App = os.popen("gconftool-2 -g /desktop/gnome/url-handlers/mailto/command").read().rsplit("/", 1)[-1].split(" ", 1)[0]
		return App
	else:
		print "There's no support for looking up the apps for \"" + Type + "\""
	return 0
