#!/usr/bin/env python

#Imports
import os
import gettext
import localez


#Translate function
__ = gettext.gettext


#Translate class
class Translate:

	#Constructor
	def __init__(self):
		
		#Set translate function
		self.translate = gettext.gettext
	
	
	#Set up gettext
	def setup(self):

		#Some get text stuff
		gettext.bindtextdomain('ubuntu-tour', "%susr%sshare%slocale" % (os.sep, os.sep, os.sep))
		gettext.textdomain('ubuntu-tour')

		#Set locale
		locale.setlocale(LC_ALL, "")
	
	
	#Set translate function
	def set_translate_function(self, function):
		self.translate = function
	
	
	#Get translatable strings
	def get_strings(self, string):
	
		#Loop through all the blocks which need translating
		peices = string.split("__(")
		strings = []
		for p in peices:
	
			#Some parsing constants
			open_braces = 0
			skip = False
			position = 0
		
			#Loop through all the characters
			for char in p:
			
				#Different actions depending on what we are doing
				if not skip:
			
					if char == "\\":
						skip = True
			
					elif char == "(":
						open_braces += 1
			
					elif char == ")":
						open_braces -= 1
				
				
					#Did we match the bracket
					if open_braces < 0:
						s = p[:position]
						if not s in strings:
							strings.append(s)
						break
			
				#Move along 1
				position += 1
		
		#Return the strings
		return strings
	
	
	#Translate some text
	def translate(self, string):
		
		#Get strings
		to_replace = self.get_strings(string)z
			
		#Now for each of the items to be translated
		for s in to_replace:
			s = s.replace("\\(", "(").replace("\\)",")")
			string = string.replace("__(" + s + ")", self.translate(s))
	
		#Return the string
		return string
	
	
	#Create pot
	def create_pot_array(self, string, file, array={}):
		
		#Get strings 
		strings = self.get_strings(string)
		
		#Get keys
		keys = array.keys()
		
		#Loop through strings
		for string in strings:
			if string in keys:
				if not file in array[string]:
					array[string].append(file)
			else:
				array[string] = [file]
		
		#Return the array
		return array
