#Using gtk
import gtk
import pygtk
import gobject
import pango
import cairo

#Breadcrumbs
import pathbar_gtk_atk as pathbar

#Basic
import os,sys
import mimetypes
import traceback


#Breadcrumbs widget
class BreadCrumb(pathbar.PathBar):

	#Initialize function
	def __init__(self, items=[], header=False, separator='/'):
	
		#Since its bases on a Drawing area, start it like one.
		pathbar.PathBar.__init__(self, None, header)

		#Get the items
		self.current = []
		self.items = items
		self.go_to_items()

		#Separator
		self.sep = separator
		
		#Create a viewport
		self.viewport = gtk.Viewport()
		self.viewport.add(self)
		self.viewport.set_property("shadow-type",gtk.SHADOW_NONE)
		
		#Create a hbox
		
		"""
		self.scroll = gtk.ScrolledWindow()
		self.scroll.set_policy(gtk.POLICY_NEVER,gtk.POLICY_NEVER)
		self.scroll.set_placement(gtk.CORNER_TOP_RIGHT)
		self.scroll.set_shadow_type(gtk.SHADOW_NONE)
		self.scroll.add_with_viewport(self)
		"""


	#Update the breadcrumbs
	def go_to_items(self):

		#We may not need to remove and add, if we are just giong to a previous point on our breadcrumb trail
		if self.items == self.current[0:len(self.items)]:

			#Just set this as the active one
			if len(self.items) > 0:
				self.set_active(self.get_children()[len(self.items)-1], False)

		#Then again, we may
		else:

			#Compare the items
			u = 0
			while u < len(self.current) and u < len(self.items) and self.current[u] == self.items[u]:
				u += 1
		
			#Remove old ones no longer valid
			children = self.get_children()
			while len(children) > u:
				self.remove(children[-1])
				children = self.get_children()
			#print self.items
			#print self.items[u:]

			#Add new ones
			for item in self.items[u:]:
				child = pathbar.PathPart(self, item, self.child_calback)
				#child.connect('button_release',self.child_clicked)
				self.append(child,False)

			#Now this is the current position
			self.current = self.items

	#Update items
	def set_items(self,items,goto=True):
		self.items = items
		if goto:
			self.go_to_items()

	#Get items
	def get_items(self):
		return self.items

	#When a child is clicked
	def child_calback(self, bar, child):
		children = self.get_children()
		n = 0
		while children[n]._created != child._created:
			n += 1
		self.items = self.current[0:n+1]
		
		self.do_callback('activated', self.items)
	
	#Create a callback
	def set_callback(self, action, function):
		#Add function to list of callbacks
		try:
			self.callbacks[action] = function
		except:
			self.callbacks = {}
			self.callbacks[action] = function
			
		
	#Do a callback
	def do_callback(self, action, params):
		#See if callback exists
		if action in self.callbacks.keys():
			#Call the function
			self.callbacks[action](self, params)
