#!/usr/bin/env python

#Imports
import os
import gettext
import locale

#Some constants
DOMAIN = 'ubuntutour'
#LOCALDIR = os.path.join(os.getcwd(), 'lang')
LOCALDIR = '/usr/share/locale/'

#Translate class
class Translate:

	#Constructor
	def __init__(self):
		
		#Set translate function
		self.translate = gettext.gettext
		LOCALDIR = os.path.join(os.getcwd(), 'lang')
	
	
	#Set up gettext
	@staticmethod
	def setup():

		#Some get text stuff
		gettext.bindtextdomain(DOMAIN, LOCALDIR)
		gettext.textdomain(DOMAIN)

		#Set locale
		locale.setlocale(locale.LC_ALL, "")
	
	
	#Set translate function
	def set_translate_function(self, function):
		self.translate = function
	
	
	#Get translatable strings
	def get_strings(self, string, note_line=False):
		
		#If we are noting the line number
		if note_line:
			line_no = 1
		
		#Create an empty list
		strings = {} if note_line else []
		
		#Loop through all the blocks which need translating
		peices = string.split("__(")
		for p in peices:
	
			#Some parsing constants
			open_braces = 0
			skip = False
			position = 0
		
			#Loop through all the characters
			for char in p:
				
				#Detect a new line
				if note_line:
					if char == "\n":
						line_no += 1
				
				#Different actions depending on what we are doing
				if not skip:
			
					if char == "\\":
						skip = True
			
					elif char == "(":
						open_braces += 1
			
					elif char == ")":
						open_braces -= 1
				
				
					#Did we match the bracket
					if open_braces < 0:
						s = p[:position]
						if note_line:
							if s in strings.keys():
								strings[s].append(line_no)
							else:
								strings[s] = [line_no]
							line_no += p[position:].count('\n')
						else:
							if not s in strings:
								strings.append(s)
						break
			
				#Move along 1
				position += 1
		
		#Return the strings
		return strings
	
	
	#Translate some text
	def translate_string(self, string):
		
		#Get strings
		to_replace = self.get_strings(string)
			
		#Now for each of the items to be translated
		for s in to_replace:
			s = s.replace("\\(", "(").replace("\\)",")")
			string = string.replace("__(" + s + ")", self.translate(s))
		
		#Return the string
		return string
	
	
	#Create pot
	def create_pot_array(self, string, file, array={}):
		
		#Get strings 
		strings = self.get_strings(string, True)
		
		#Get keys
		keys = array.keys()
		
		#Loop through strings
		for string in strings.keys():
			if string in keys:
				for line in strings[string]:
					pos = '#: ' + file + ':' + str(line)
					if not pos in array[string]:
						array[string].append(pos)
			else:
				for line in strings[string]:
					pos = '#: ' + file + ':' + str(line)
					array[string] = [pos]
		
		#Return the array
		return array
